/*
 * readS0: read remote control codes from the TiVo remote
 * (c) 2002, Warren Toomey wkt@tuhs.org.
 * Released under the Gnu General Public License version 2
 */

#include <sys/types.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <signal.h>
#include <termios.h>
#include <sys/stat.h>

struct termios oldtios, newtios;	/* Console settings for raw & cooked */
					/* modes */

/* Set a fd into nonblocking mode */
void
set_nonblocking(int fd)
{
  int val;

  if ((val = fcntl(fd, F_GETFL, 0)) == -1) return;
  if (!(val & O_NONBLOCK)) {
    val |= O_NONBLOCK;
    fcntl(fd, F_SETFL, val);
  }
}

int main(int argc, char *argv[])
{
 int remotefd;
 char c;
 int i,ret;

 remotefd=open("/dev/ttyS0", O_RDONLY);


  /* Set ttyS0 to raw mode & non-blocking,
   * so we can get single character commands
   */
  tcgetattr(remotefd, &oldtios);
  memcpy(&newtios, &oldtios, sizeof(oldtios));
  set_nonblocking(remotefd);
  cfmakeraw(&newtios);
  tcsetattr(remotefd, TCSANOW, &newtios);

  while (1) {
    ret=read(remotefd, &c, 1);
    if (ret==-1) { usleep(100000); continue; }

    printf("Received %d ",c);
    while (1) {
      ret=read(remotefd, &c, 1);
      if (ret==-1) { usleep(100000); break; }
      printf("%d ",c);
    }
    printf("\n");
  }
}
